Scriptname cdUIControlScript extends Quest  

GlobalVariable Property cdUIEnabled Auto

GlobalVariable Property cdUIToPCVE Auto
GlobalVariable Property cdUIToPCE Auto
GlobalVariable Property cdUIToPCN Auto
GlobalVariable Property cdUIToPCH Auto
GlobalVariable Property cdUIToPCVH Auto
GlobalVariable Property cdUIToPCL Auto

GlobalVariable Property cdUIByPCVE Auto
GlobalVariable Property cdUIByPCE Auto
GlobalVariable Property cdUIByPCN Auto
GlobalVariable Property cdUIByPCH Auto
GlobalVariable Property cdUIByPCVH Auto
GlobalVariable Property cdUIByPCL Auto

bool Function isActive()
	return cdUIEnabled != none && cdUIEnabled.GetValueInt() == 1
EndFunction

Function reset()
	if (isActive())
		activate()
	else
		deactivate()
	endif
endFunction

Function activate()
	setPlayerSettings()
endFunction

Function deactivate()
	setDefaultSettings()
endFunction

Function setPlayerSettings()
	Game.SetGameSettingFloat("fDiffMultHPToPCVE", cdUIToPCVE.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPToPCE", cdUIToPCE.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPToPCN", cdUIToPCN.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPToPCH", cdUIToPCH.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPToPCVH", cdUIToPCVH.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPToPCL", cdUIToPCL.GetValue()) 
	
	Game.SetGameSettingFloat("fDiffMultHPByPCVE", cdUIByPCVE.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPByPCE", cdUIByPCE.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPByPCN", cdUIByPCN.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPByPCH", cdUIByPCH.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPByPCVH", cdUIByPCVH.GetValue())
	Game.SetGameSettingFloat("fDiffMultHPByPCL", cdUIByPCL.GetValue())
endFunction

Function setDefaultSettings()
	Game.SetGameSettingFloat("fDiffMultHPToPCVE", 0.50)
	Game.SetGameSettingFloat("fDiffMultHPToPCE", 0.75)
	Game.SetGameSettingFloat("fDiffMultHPToPCN", 1.00)
	Game.SetGameSettingFloat("fDiffMultHPToPCH", 1.50)
	Game.SetGameSettingFloat("fDiffMultHPToPCVH", 2.00)
	Game.SetGameSettingFloat("fDiffMultHPToPCL", 3.00) 
	
	Game.SetGameSettingFloat("fDiffMultHPByPCVE", 2.00)
	Game.SetGameSettingFloat("fDiffMultHPByPCE", 1.50)
	Game.SetGameSettingFloat("fDiffMultHPByPCN", 1.00)
	Game.SetGameSettingFloat("fDiffMultHPByPCH", 0.75)
	Game.SetGameSettingFloat("fDiffMultHPByPCVH", 0.50)
	Game.SetGameSettingFloat("fDiffMultHPByPCL", 0.25)
endFunction

Function getCurrentSettings()
	cdUIToPCVE.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCVE") )
	cdUIToPCE.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCE") )
	cdUIToPCN.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCN") )
	cdUIToPCH.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCH") )
	cdUIToPCVH.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCVH") )
	cdUIToPCL.SetValue( Game.GetGameSettingFloat("fDiffMultHPToPCL") )
	
	cdUIByPCVE.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCVE") )
	cdUIByPCE.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCE") )
	cdUIByPCN.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCN") )
	cdUIByPCH.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCH") )
	cdUIByPCVH.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCVH") )
	cdUIByPCL.SetValue( Game.GetGameSettingFloat("fDiffMultHPByPCL") )
endFunction