Scriptname cdUISkyUIConfigMenuScript extends SKI_ConfigBase  

; SCRIPT VERSION ----------------------------------------------------------------------------------

int function GetVersion()
    return 1
endFunction


; GLOBAL VARIABLES --------------------------------------------------------------------------------

GlobalVariable Property cdUIEnabled Auto

GlobalVariable Property cdUIToPCVE Auto
GlobalVariable Property cdUIToPCE Auto
GlobalVariable Property cdUIToPCN Auto
GlobalVariable Property cdUIToPCH Auto
GlobalVariable Property cdUIToPCVH Auto
GlobalVariable Property cdUIToPCL Auto

GlobalVariable Property cdUIByPCVE Auto
GlobalVariable Property cdUIByPCE Auto
GlobalVariable Property cdUIByPCN Auto
GlobalVariable Property cdUIByPCH Auto
GlobalVariable Property cdUIByPCVH Auto
GlobalVariable Property cdUIByPCL Auto

cdUIControlScript Property cdUIControl Auto
cdUIMaintainanceScript Property cdUIMaintainance Auto


; PRIVATE VARIABLES -------------------------------------------------------------------------------

; State
int _modEnabledFlags

; Misc
string _sliderFS = "{2}"


; FUNCTIONS ---------------------------------------------------------------------------------------

Function setPages()
	Pages = new string[1]
	Pages[0] = "$Options"
endFunction

Function toggle(GlobalVariable value)
	if (value.getValueInt() == 0)
		value.setValueInt(1)
	else
		value.setValueInt(0)
	endIf
EndFunction

Function updateFlags()
	if (cdUIEnabled.GetValueInt() == 1)
		_modEnabledFlags = OPTION_FLAG_NONE
	else
		_modEnabledFlags = OPTION_FLAG_DISABLED
	endIf
endFunction

; INITIALIZATION ----------------------------------------------------------------------------------

; @overrides SKI_ConfigBase
event OnConfigInit()
	setPages()
	cdUIControl.getCurrentSettings()
endEvent

; @implements SKI_ConfigBase
event OnConfigRegister()
	if (cdUIEnabled.GetValueInt() == 1)
		Debug.Notification("$notifyModEnabled")
	else
		Debug.Notification("$notifyModDisabled")
	endIf
endEvent

; EVENTS ------------------------------------------------------------------------------------------

; @implements SKI_ConfigBase
event OnPageReset(string a_page)
	if (a_page == "")
		return
	else
		UnloadCustomContent()
	endIf

	if (a_page == "$Options")
		SetCursorFillMode(TOP_TO_BOTTOM)

		AddToggleOptionST("MOD_ENABLED", "$ActiveMod", cdUIEnabled.GetValueInt())
		AddEmptyOption()

		updateFlags()

		AddHeaderOption("$DifficultyVeryEasy")
		AddSliderOptionST("TOPC_VE", "$MultToPC", cdUIToPCVE.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_VE", "$MultByPC", cdUIByPCVE.GetValue(), _sliderFS, _modEnabledFlags)

		AddHeaderOption("$DifficultyEasy")
		AddSliderOptionST("TOPC_E", "$MultToPC", cdUIToPCE.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_E", "$MultByPC", cdUIByPCE.GetValue(), _sliderFS, _modEnabledFlags)

		AddHeaderOption("$DifficultyNormal")
		AddSliderOptionST("TOPC_N", "$MultToPC", cdUIToPCN.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_N", "$MultByPC", cdUIByPCN.GetValue(), _sliderFS, _modEnabledFlags)
		
		SetCursorPosition(1)
		AddTextOptionST("MOD_VERSION", "$ModVersion", cdUIMaintainance.getcdUIVersion())
		AddEmptyOption()

		AddHeaderOption("$DifficultyHigh")
		AddSliderOptionST("TOPC_H", "$MultToPC", cdUIToPCH.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_H", "$MultByPC", cdUIByPCH.GetValue(), _sliderFS, _modEnabledFlags)

		AddHeaderOption("$DifficultyVeryHigh")
		AddSliderOptionST("TOPC_VH", "$MultToPC", cdUIToPCVH.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_VH", "$MultByPC", cdUIByPCVH.GetValue(), _sliderFS, _modEnabledFlags)

		AddHeaderOption("$DifficultyLegendary")
		AddSliderOptionST("TOPC_L", "$MultToPC", cdUIToPCL.GetValue(), _sliderFS, _modEnabledFlags)
		AddSliderOptionST("BYPC_L", "$MultByPC", cdUIByPCL.GetValue(), _sliderFS, _modEnabledFlags)
	endIf
endEvent

event OnConfigClose()
	cdUIControl.reset()
endEvent


; MENU OPTION EVENTS ------------------------------------------------------------------------------

state MOD_ENABLED ; TOGGLE
	event onSelectST()
		toggle(cdUIEnabled)
		SetToggleOptionValueST(cdUIEnabled.GetValueInt())
		ForcePageReset()
	endEvent
    
	event OnHighlightST()
		SetInfoText("$hintActivateMod")
	endEvent
endState

state MOD_VERSION ; TEXT

endState

; VERY EASY

state TOPC_VE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCVE.GetValue())
		SetSliderDialogDefaultValue(0.5)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCVE.SetValue(value)
		SetSliderOptionValueST(cdUIToPCVE.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(0.5, _sliderFS)
	endEvent
endState

state BYPC_VE ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCVE.GetValue())
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCVE.SetValue(value)
		SetSliderOptionValueST(cdUIByPCVE.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(2.0, _sliderFS)
	endEvent
endState

; EASY

state TOPC_E ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCE.GetValue())
		SetSliderDialogDefaultValue(0.75)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCE.SetValue(value)
		SetSliderOptionValueST(cdUIToPCE.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(0.75, _sliderFS)
	endEvent
endState

state BYPC_E ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCE.GetValue())
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCE.SetValue(value)
		SetSliderOptionValueST(cdUIByPCE.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(1.5, _sliderFS)
	endEvent
endState

; NORMAL

state TOPC_N ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCN.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCN.SetValue(value)
		SetSliderOptionValueST(cdUIToPCN.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(1.0, _sliderFS)
	endEvent
endState

state BYPC_N ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCN.GetValue())
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCN.SetValue(value)
		SetSliderOptionValueST(cdUIByPCN.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(1.0, _sliderFS)
	endEvent
endState

; HIGH

state TOPC_H ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCH.GetValue())
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCH.SetValue(value)
		SetSliderOptionValueST(cdUIToPCH.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(1.5, _sliderFS)
	endEvent
endState

state BYPC_H ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCH.GetValue())
		SetSliderDialogDefaultValue(0.75)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCH.SetValue(value)
		SetSliderOptionValueST(cdUIByPCH.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(0.75, _sliderFS)
	endEvent
endState

; VERY HIGH

state TOPC_VH ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCVH.GetValue())
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCVH.SetValue(value)
		SetSliderOptionValueST(cdUIToPCVH.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(2.0, _sliderFS)
	endEvent
endState

state BYPC_VH ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCVH.GetValue())
		SetSliderDialogDefaultValue(0.5)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCVH.SetValue(value)
		SetSliderOptionValueST(cdUIByPCVH.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(0.5, _sliderFS)
	endEvent
endState

; LEGENDARY

state TOPC_L ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIToPCL.GetValue())
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIToPCL.SetValue(value)
		SetSliderOptionValueST(cdUIToPCL.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(3.0, _sliderFS)
	endEvent
endState

state BYPC_L ; SLIDER
	event OnSliderOpenST()
		SetSliderDialogStartValue(cdUIByPCL.GetValue())
		SetSliderDialogDefaultValue(0.25)
		SetSliderDialogRange(0.1, 5.0)
		SetSliderDialogInterval(0.1)
	endEvent
    
	event OnSliderAcceptST(float value)
		cdUIByPCL.SetValue(value)
		SetSliderOptionValueST(cdUIByPCL.GetValue(), _sliderFS)
	endEvent
	
	event OnDefaultST()
		SetSliderOptionValueST(0.25, _sliderFS)
	endEvent
endState
